<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>app.routes &mdash; AIoD Broker 0.01 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />

  
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6ca3c713"></script>
        <script src="../../_static/doctools.js?v=9a2dae69"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
        <script src="../../_static/copybutton.js?v=f281be69"></script>
        <script src="../../_static/custom.js?v=45d98342"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            AIoD Broker
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../introduction.html">Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../architecture.html">Architecture</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../context.html">Context Diagram</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../container.html">Container Diagram</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../component.html">Component Diagram</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../data_flow.html">Data Flow Chart</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../setup_deployment.html">Setup/Deployment</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../prerequisites.html">Prerequisites</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../prerequisites.html#aiod-api-installation">AIoD API Installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../prerequisites.html#repository-installation">Repository Installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../prerequisites.html#configuration">Configuration</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../deployment.html">Docker Deployment</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../deployment.html#service-information">Service Information</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../installation.html">Native Installation</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../installation.html#python-environment-and-nodejs-setup">Python Environment and NodeJS Setup</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../installation.html#using-virtualenv">Using Virtualenv</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../installation.html#using-conda">Using Conda</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../documentation.html">Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../app_services.html">Services</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.add_dataset"><code class="docutils literal notranslate"><span class="pre">add_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.convert_date_to_iso_format"><code class="docutils literal notranslate"><span class="pre">convert_date_to_iso_format()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.fetch_dataset"><code class="docutils literal notranslate"><span class="pre">fetch_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.generate_string"><code class="docutils literal notranslate"><span class="pre">generate_string()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.get_platform_id_by_dataset_name"><code class="docutils literal notranslate"><span class="pre">get_platform_id_by_dataset_name()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.keycloak_openid"><code class="docutils literal notranslate"><span class="pre">keycloak_openid()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.logging"><code class="docutils literal notranslate"><span class="pre">logging()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.login"><code class="docutils literal notranslate"><span class="pre">login()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.parse2payload"><code class="docutils literal notranslate"><span class="pre">parse2payload()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.publish"><code class="docutils literal notranslate"><span class="pre">publish()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.readAIODglossary"><code class="docutils literal notranslate"><span class="pre">readAIODglossary()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.remove_dataset"><code class="docutils literal notranslate"><span class="pre">remove_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.send_dataset_to_platform"><code class="docutils literal notranslate"><span class="pre">send_dataset_to_platform()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.set_nested_value"><code class="docutils literal notranslate"><span class="pre">set_nested_value()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.translate2AIoD"><code class="docutils literal notranslate"><span class="pre">translate2AIoD()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.update_dataset_to_platform"><code class="docutils literal notranslate"><span class="pre">update_dataset_to_platform()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.update_modify_date_entry"><code class="docutils literal notranslate"><span class="pre">update_modify_date_entry()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.user_exists"><code class="docutils literal notranslate"><span class="pre">user_exists()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../app_routing.html">Routes</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.get_dataset"><code class="docutils literal notranslate"><span class="pre">get_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.index"><code class="docutils literal notranslate"><span class="pre">index()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.login"><code class="docutils literal notranslate"><span class="pre">login()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.publish"><code class="docutils literal notranslate"><span class="pre">publish()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.translate_metadata"><code class="docutils literal notranslate"><span class="pre">translate_metadata()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">AIoD Broker</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content style-external-links">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../index.html">Module code</a></li>
      <li class="breadcrumb-item active">app.routes</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for app.routes</h1><div class="highlight"><pre>
<span></span><span class="c1"># MIT License</span>

<span class="c1"># Copyright (c) 2024 University College Cork</span>

<span class="c1"># Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<span class="c1"># of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<span class="c1"># in the Software without restriction, including without limitation the rights</span>
<span class="c1"># to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<span class="c1"># copies of the Software, and to permit persons to whom the Software is</span>
<span class="c1"># furnished to do so, subject to the following conditions:</span>

<span class="c1"># The above copyright notice and this permission notice shall be included in all</span>
<span class="c1"># copies or substantial portions of the Software.</span>

<span class="c1"># THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<span class="c1"># IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<span class="c1"># FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<span class="c1"># AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<span class="c1"># LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<span class="c1"># OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span>
<span class="c1"># SOFTWARE.</span>

<span class="kn">from</span> <span class="nn">app</span> <span class="kn">import</span> <span class="n">app</span>
<span class="kn">import</span> <span class="nn">app.services</span> <span class="k">as</span> <span class="nn">sv</span>
<span class="kn">import</span> <span class="nn">app.models</span> <span class="k">as</span> <span class="nn">ml</span>
<span class="kn">from</span> <span class="nn">flask</span> <span class="kn">import</span> <span class="n">jsonify</span><span class="p">,</span> <span class="n">request</span><span class="p">,</span> <span class="n">render_template</span>
<span class="kn">from</span> <span class="nn">werkzeug.utils</span> <span class="kn">import</span> <span class="n">secure_filename</span>

<span class="c1"># ------ API Calls ------ </span>

<span class="c1"># Renders the html homepage.</span>
<div class="viewcode-block" id="index">
<a class="viewcode-back" href="../../app_routing.html#app.routes.index">[docs]</a>
<span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">)</span>
<span class="k">def</span> <span class="nf">index</span><span class="p">():</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Renders the html homepage.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">link1</span> <span class="o">=</span> <span class="s2">&quot;http://&quot;</span><span class="o">+</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;SERVICE_IP&quot;</span><span class="p">]</span><span class="o">+</span><span class="s2">&quot;:&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;SERVICE_PORT&quot;</span><span class="p">])</span><span class="o">+</span><span class="s2">&quot;/apidocs/&quot;</span>
        <span class="n">link2</span> <span class="o">=</span> <span class="s2">&quot;http://&quot;</span><span class="o">+</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;TESTCASE_IP&quot;</span><span class="p">]</span><span class="o">+</span><span class="s2">&quot;:&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;TESTCASE_PORT&quot;</span><span class="p">])</span><span class="o">+</span><span class="s2">&quot;/&quot;</span>
        <span class="n">link3</span> <span class="o">=</span> <span class="s2">&quot;https://aiod-broker.readthedocs.io/en/latest/introduction.html&quot;</span>
        <span class="k">return</span> <span class="n">render_template</span><span class="p">(</span><span class="s1">&#39;index.html&#39;</span><span class="p">,</span><span class="n">link_api_documentation</span><span class="o">=</span><span class="n">link1</span><span class="p">,</span><span class="n">link_test_usecase</span><span class="o">=</span><span class="n">link2</span><span class="p">,</span><span class="n">link_service_documentation</span><span class="o">=</span><span class="n">link3</span><span class="p">)</span>

    <span class="k">except</span><span class="p">:</span>
        <span class="n">app</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s1">&#39;Error: README.md file was not found.&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="s2">&quot;Error: File was not found!&quot;</span><span class="p">,</span> <span class="mi">500</span></div>


<span class="c1"># The user can fetch the translated metadata from the AIoD.</span>
<div class="viewcode-block" id="get_dataset">
<a class="viewcode-back" href="../../app_routing.html#app.routes.get_dataset">[docs]</a>
<span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/api/datasets_metadata&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="k">def</span> <span class="nf">get_dataset</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="nb">tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">int</span><span class="p">]:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    The user can fetch the translated metadata from the AIoD.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">        tuple: The requested datasets&#39; metadata from the AIoD platform.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">dataset_ids</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">json</span>
        <span class="n">dataset_metadata</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">fetch_dataset</span><span class="p">(</span><span class="n">dataset_ids</span><span class="p">[</span><span class="s2">&quot;datasets&quot;</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">dataset_metadata</span><span class="p">),</span> <span class="mi">200</span>
    <span class="k">except</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: API server is down.&#39;</span><span class="p">}),</span> <span class="mi">500</span></div>


<span class="c1"># The user can upload metadata in datamite&#39;s format and receive the translated version of the metadata in AIoD&#39;s format.</span>
<div class="viewcode-block" id="translate_metadata">
<a class="viewcode-back" href="../../app_routing.html#app.routes.translate_metadata">[docs]</a>
<span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/api/translate_metadata&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="k">def</span> <span class="nf">translate_metadata</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="nb">tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">int</span><span class="p">]:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    The user can upload metadata in datamite&#39;s format and receive the translated version of the metadata in AIoD&#39;s format.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">        tuple: The uploaded metadata in AIoD&#39;s format.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="c1"># receives metadata from api call </span>
        <span class="n">metadata</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">json</span>

        <span class="c1"># read AIoD (portal) glassary</span>
        <span class="n">glossary</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">readAIODglossary</span><span class="p">()</span>

        <span class="c1"># get EU portal metadata</span>
        <span class="n">portal_metadata</span><span class="o">=</span><span class="n">sv</span><span class="o">.</span><span class="n">translate2AIoD</span><span class="p">(</span><span class="n">metadata</span><span class="p">,</span><span class="n">glossary</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">portal_metadata</span><span class="p">),</span> <span class="mi">200</span>
    <span class="k">except</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: Metadata structure was Incorrect.&#39;</span><span class="p">}),</span> <span class="mi">422</span></div>


<span class="c1"># Login to the AIoD platform.</span>
<div class="viewcode-block" id="login">
<a class="viewcode-back" href="../../app_routing.html#app.routes.login">[docs]</a>
<span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/api/login_eu_portal&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="k">def</span> <span class="nf">login</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="nb">tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">int</span><span class="p">]:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Login to the AIoD platform.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">        tuple: The username and user-id if the login procedure is successful, an error message otherwise.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="c1"># receives user credentials</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">json</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">user_exists</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;user&quot;</span><span class="p">],</span> <span class="n">user</span><span class="p">[</span><span class="s2">&quot;username&quot;</span><span class="p">])</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">response</span><span class="p">[</span><span class="s2">&quot;status&quot;</span><span class="p">]):</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">response</span><span class="p">[</span><span class="s2">&quot;object&quot;</span><span class="p">][</span><span class="s2">&quot;password&quot;</span><span class="p">]</span><span class="o">==</span><span class="n">user</span><span class="p">[</span><span class="s2">&quot;password&quot;</span><span class="p">]):</span>
                <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s2">&quot;username&quot;</span><span class="p">:</span><span class="n">user</span><span class="p">[</span><span class="s2">&quot;username&quot;</span><span class="p">],</span><span class="s2">&quot;id&quot;</span><span class="p">:</span><span class="n">response</span><span class="p">[</span><span class="s2">&quot;object&quot;</span><span class="p">][</span><span class="s2">&quot;id&quot;</span><span class="p">]}),</span> <span class="mi">200</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: Credentials were Incorrect.&#39;</span><span class="p">}),</span> <span class="mi">422</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">token</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">login</span><span class="p">(</span><span class="n">user</span><span class="p">[</span><span class="s2">&quot;username&quot;</span><span class="p">],</span><span class="n">user</span><span class="p">[</span><span class="s2">&quot;password&quot;</span><span class="p">])</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">token</span> <span class="o">==</span> <span class="kc">None</span><span class="p">):</span>
                <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: Credentials were Incorrect.&#39;</span><span class="p">}),</span> <span class="mi">422</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="nb">id</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">generate_string</span><span class="p">()</span>
                <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;user&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">({</span>
                        <span class="s2">&quot;username&quot;</span><span class="p">:</span> <span class="n">user</span><span class="p">[</span><span class="s2">&quot;username&quot;</span><span class="p">],</span>
                        <span class="s2">&quot;password&quot;</span><span class="p">:</span> <span class="n">user</span><span class="p">[</span><span class="s2">&quot;password&quot;</span><span class="p">],</span>
                        <span class="s2">&quot;id&quot;</span><span class="p">:</span> <span class="nb">id</span><span class="p">,</span>
                        <span class="s2">&quot;token&quot;</span><span class="p">:</span> <span class="n">token</span>
                <span class="p">})</span>
                <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s2">&quot;username&quot;</span><span class="p">:</span><span class="n">user</span><span class="p">[</span><span class="s2">&quot;username&quot;</span><span class="p">],</span><span class="s2">&quot;id&quot;</span><span class="p">:</span><span class="nb">id</span><span class="p">}),</span> <span class="mi">200</span>
    <span class="k">except</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: The authentication server is down.&#39;</span><span class="p">}),</span> <span class="mi">500</span></div>


<span class="c1"># Publishes datasets&#39; metadata to the AIoD platform.</span>
<div class="viewcode-block" id="publish">
<a class="viewcode-back" href="../../app_routing.html#app.routes.publish">[docs]</a>
<span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/api/publish_eu_portal&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="k">def</span> <span class="nf">publish</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="nb">tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">int</span><span class="p">]:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Publishes datasets&#39; metadata to the AIoD platform.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">        tuple: The AIoD&#39;s API responses to the calls.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="c1"># receives metadata</span>
        <span class="n">data</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">json</span>
        
        <span class="c1"># check if the user exists</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">user_exists</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;user&quot;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;user&quot;</span><span class="p">][</span><span class="s2">&quot;username&quot;</span><span class="p">])</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">response</span><span class="p">[</span><span class="s2">&quot;status&quot;</span><span class="p">]):</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">response</span><span class="p">[</span><span class="s2">&quot;object&quot;</span><span class="p">][</span><span class="s2">&quot;id&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;user&quot;</span><span class="p">][</span><span class="s2">&quot;id&quot;</span><span class="p">]):</span>

                <span class="n">res</span> <span class="o">=</span> <span class="n">sv</span><span class="o">.</span><span class="n">publish</span><span class="p">(</span><span class="n">data</span><span class="p">,</span><span class="n">response</span><span class="p">[</span><span class="s2">&quot;object&quot;</span><span class="p">][</span><span class="s2">&quot;token&quot;</span><span class="p">])</span>

                <span class="c1"># log publishing to logging service</span>
                <span class="n">ids</span> <span class="o">=</span> <span class="p">[</span><span class="nb">id</span><span class="p">[</span><span class="s1">&#39;identifier&#39;</span><span class="p">]</span> <span class="k">for</span> <span class="nb">id</span> <span class="ow">in</span> <span class="n">res</span><span class="p">]</span>
                <span class="n">sv</span><span class="o">.</span><span class="n">logging</span><span class="p">(</span><span class="n">ids</span><span class="p">)</span>

                <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">res</span><span class="p">),</span> <span class="mi">200</span>

        <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: Metadata structure was Incorrect.&#39;</span><span class="p">}),</span> <span class="mi">422</span>
    <span class="k">except</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;message&#39;</span><span class="p">:</span> <span class="s1">&#39;Error: API server is down.&#39;</span><span class="p">}),</span> <span class="mi">500</span></div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024 University College Cork.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>